// Generated from C:\Projects\Visual_Studio\CutsceneDSL\CutsceneGrammar\Actor.g4 by ANTLR 4.0.1-SNAPSHOT
using Antlr4.Runtime;
using Antlr4.Runtime.Atn;
using Antlr4.Runtime.Misc;
using Antlr4.Runtime.Tree;
using System.Collections.Generic;
using DFA = Antlr4.Runtime.Dfa.DFA;

public partial class ActorParser : Parser {
	public const int
		T__12=1, T__11=2, T__10=3, T__9=4, T__8=5, T__7=6, T__6=7, T__5=8, T__4=9, 
		T__3=10, T__2=11, T__1=12, T__0=13, Digit=14, Name=15, Whitespace=16;
	public static readonly string[] tokenNames = {
		"<INVALID>", "'colorR'", "'animations'", "','", "'flipped_x;'", "'['", 
		"'='", "';'", "'];'", "'images'", "'colorB'", "'{'", "'colorG'", "'}'", 
		"Digit", "Name", "Whitespace"
	};
	public const int
		RULE_actor = 0, RULE_properties = 1, RULE_propertyColorR = 2, RULE_propertyColorG = 3, 
		RULE_propertyColorB = 4, RULE_animations = 5, RULE_animation = 6, RULE_flippedAnimation = 7, 
		RULE_animationFrames = 8, RULE_frames = 9, RULE_frame = 10;
	public static readonly string[] ruleNames = {
		"actor", "properties", "propertyColorR", "propertyColorG", "propertyColorB", 
		"animations", "animation", "flippedAnimation", "animationFrames", "frames", 
		"frame"
	};

	public override string GrammarFileName { get { return "Actor.g4"; } }

	public override string[] TokenNames { get { return tokenNames; } }

	public override string[] RuleNames { get { return ruleNames; } }

	public ActorParser(ITokenStream input)
		: base(input)
	{
		_interp = new ParserATNSimulator(this,_ATN);
	}
	public partial class ActorContext : ParserRuleContext {
		public AnimationsContext animations() {
			return GetRuleContext<AnimationsContext>(0);
		}
		public PropertiesContext properties() {
			return GetRuleContext<PropertiesContext>(0);
		}
		public ActorContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_actor; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterActor(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitActor(this);
		}
	}

	[RuleVersion(0)]
	public ActorContext actor() {
		ActorContext _localctx = new ActorContext(_ctx, State);
		EnterRule(_localctx, 0, RULE_actor);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 23;
			switch ( Interpreter.AdaptivePredict(_input,0,_ctx) ) {
			case 1:
				{
				State = 22; properties();
				}
				break;
			}
			State = 25; animations();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class PropertiesContext : ParserRuleContext {
		public PropertyColorBContext propertyColorB() {
			return GetRuleContext<PropertyColorBContext>(0);
		}
		public PropertyColorRContext propertyColorR() {
			return GetRuleContext<PropertyColorRContext>(0);
		}
		public PropertyColorGContext propertyColorG() {
			return GetRuleContext<PropertyColorGContext>(0);
		}
		public PropertiesContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_properties; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterProperties(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitProperties(this);
		}
	}

	[RuleVersion(0)]
	public PropertiesContext properties() {
		PropertiesContext _localctx = new PropertiesContext(_ctx, State);
		EnterRule(_localctx, 2, RULE_properties);
		int _la;
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 28;
			_la = _input.La(1);
			if (_la==1) {
				{
				State = 27; propertyColorR();
				}
			}

			State = 31;
			_la = _input.La(1);
			if (_la==12) {
				{
				State = 30; propertyColorG();
				}
			}

			State = 34;
			_la = _input.La(1);
			if (_la==10) {
				{
				State = 33; propertyColorB();
				}
			}

			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class PropertyColorRContext : ParserRuleContext {
		public ITerminalNode Digit() { return GetToken(ActorParser.Digit, 0); }
		public PropertyColorRContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_propertyColorR; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterPropertyColorR(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitPropertyColorR(this);
		}
	}

	[RuleVersion(0)]
	public PropertyColorRContext propertyColorR() {
		PropertyColorRContext _localctx = new PropertyColorRContext(_ctx, State);
		EnterRule(_localctx, 4, RULE_propertyColorR);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 36; Match(1);
			State = 37; Match(6);
			State = 38; Match(Digit);
			State = 39; Match(7);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class PropertyColorGContext : ParserRuleContext {
		public ITerminalNode Digit() { return GetToken(ActorParser.Digit, 0); }
		public PropertyColorGContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_propertyColorG; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterPropertyColorG(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitPropertyColorG(this);
		}
	}

	[RuleVersion(0)]
	public PropertyColorGContext propertyColorG() {
		PropertyColorGContext _localctx = new PropertyColorGContext(_ctx, State);
		EnterRule(_localctx, 6, RULE_propertyColorG);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 41; Match(12);
			State = 42; Match(6);
			State = 43; Match(Digit);
			State = 44; Match(7);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class PropertyColorBContext : ParserRuleContext {
		public ITerminalNode Digit() { return GetToken(ActorParser.Digit, 0); }
		public PropertyColorBContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_propertyColorB; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterPropertyColorB(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitPropertyColorB(this);
		}
	}

	[RuleVersion(0)]
	public PropertyColorBContext propertyColorB() {
		PropertyColorBContext _localctx = new PropertyColorBContext(_ctx, State);
		EnterRule(_localctx, 8, RULE_propertyColorB);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 46; Match(10);
			State = 47; Match(6);
			State = 48; Match(Digit);
			State = 49; Match(7);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class AnimationsContext : ParserRuleContext {
		public AnimationContext animation(int i) {
			return GetRuleContext<AnimationContext>(i);
		}
		public AnimationContext[] animation() {
			return GetRuleContexts<AnimationContext>();
		}
		public AnimationsContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_animations; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterAnimations(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitAnimations(this);
		}
	}

	[RuleVersion(0)]
	public AnimationsContext animations() {
		AnimationsContext _localctx = new AnimationsContext(_ctx, State);
		EnterRule(_localctx, 10, RULE_animations);
		int _la;
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 51; Match(2);
			State = 52; Match(6);
			State = 53; Match(11);
			State = 57;
			_errHandler.Sync(this);
			_la = _input.La(1);
			while (_la==Name) {
				{
				{
				State = 54; animation();
				}
				}
				State = 59;
				_errHandler.Sync(this);
				_la = _input.La(1);
			}
			State = 60; Match(13);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class AnimationContext : ParserRuleContext {
		public ITerminalNode Name() { return GetToken(ActorParser.Name, 0); }
		public AnimationFramesContext animationFrames() {
			return GetRuleContext<AnimationFramesContext>(0);
		}
		public FlippedAnimationContext flippedAnimation() {
			return GetRuleContext<FlippedAnimationContext>(0);
		}
		public AnimationContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_animation; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterAnimation(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitAnimation(this);
		}
	}

	[RuleVersion(0)]
	public AnimationContext animation() {
		AnimationContext _localctx = new AnimationContext(_ctx, State);
		EnterRule(_localctx, 12, RULE_animation);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 62; Match(Name);
			State = 63; Match(6);
			State = 64; Match(11);
			State = 67;
			switch (_input.La(1)) {
			case 4:
				{
				State = 65; flippedAnimation();
				}
				break;
			case 9:
				{
				State = 66; animationFrames();
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
			State = 69; Match(13);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class FlippedAnimationContext : ParserRuleContext {
		public AnimationFramesContext animationFrames() {
			return GetRuleContext<AnimationFramesContext>(0);
		}
		public FlippedAnimationContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_flippedAnimation; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterFlippedAnimation(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitFlippedAnimation(this);
		}
	}

	[RuleVersion(0)]
	public FlippedAnimationContext flippedAnimation() {
		FlippedAnimationContext _localctx = new FlippedAnimationContext(_ctx, State);
		EnterRule(_localctx, 14, RULE_flippedAnimation);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 71; Match(4);
			State = 72; animationFrames();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class AnimationFramesContext : ParserRuleContext {
		public FramesContext[] frames() {
			return GetRuleContexts<FramesContext>();
		}
		public FramesContext frames(int i) {
			return GetRuleContext<FramesContext>(i);
		}
		public AnimationFramesContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_animationFrames; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterAnimationFrames(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitAnimationFrames(this);
		}
	}

	[RuleVersion(0)]
	public AnimationFramesContext animationFrames() {
		AnimationFramesContext _localctx = new AnimationFramesContext(_ctx, State);
		EnterRule(_localctx, 16, RULE_animationFrames);
		int _la;
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 74; Match(9);
			State = 75; Match(6);
			State = 76; Match(5);
			State = 80;
			_errHandler.Sync(this);
			_la = _input.La(1);
			while (_la==Name) {
				{
				{
				State = 77; frames();
				}
				}
				State = 82;
				_errHandler.Sync(this);
				_la = _input.La(1);
			}
			State = 83; Match(8);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class FramesContext : ParserRuleContext {
		public FrameContext frame() {
			return GetRuleContext<FrameContext>(0);
		}
		public FramesContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_frames; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterFrames(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitFrames(this);
		}
	}

	[RuleVersion(0)]
	public FramesContext frames() {
		FramesContext _localctx = new FramesContext(_ctx, State);
		EnterRule(_localctx, 18, RULE_frames);
		try {
			State = 89;
			switch ( Interpreter.AdaptivePredict(_input,7,_ctx) ) {
			case 1:
				EnterOuterAlt(_localctx, 1);
				{
				State = 85; frame();
				}
				break;

			case 2:
				EnterOuterAlt(_localctx, 2);
				{
				{
				State = 86; frame();
				State = 87; Match(3);
				}
				}
				break;
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public partial class FrameContext : ParserRuleContext {
		public ITerminalNode Name() { return GetToken(ActorParser.Name, 0); }
		public FrameContext(ParserRuleContext parent, int invokingState)
			: base(parent, invokingState)
		{
		}
		public override int GetRuleIndex() { return RULE_frame; }
		public override void EnterRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.EnterFrame(this);
		}
		public override void ExitRule(IParseTreeListener listener) {
			IActorListener typedListener = listener as IActorListener;
			if (typedListener != null) typedListener.ExitFrame(this);
		}
	}

	[RuleVersion(0)]
	public FrameContext frame() {
		FrameContext _localctx = new FrameContext(_ctx, State);
		EnterRule(_localctx, 20, RULE_frame);
		try {
			EnterOuterAlt(_localctx, 1);
			{
			State = 91; Match(Name);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.ReportError(this, re);
			_errHandler.Recover(this, re);
		}
		finally {
			ExitRule();
		}
		return _localctx;
	}

	public static readonly string _serializedATN =
		"\x5\x3\x12`\x4\x2\t\x2\x4\x3\t\x3\x4\x4\t\x4\x4\x5\t\x5\x4\x6\t\x6\x4"+
		"\a\t\a\x4\b\t\b\x4\t\t\t\x4\n\t\n\x4\v\t\v\x4\f\t\f\x3\x2\x5\x2\x1A\n"+
		"\x2\x3\x2\x3\x2\x3\x3\x5\x3\x1F\n\x3\x3\x3\x5\x3\"\n\x3\x3\x3\x5\x3%\n"+
		"\x3\x3\x4\x3\x4\x3\x4\x3\x4\x3\x4\x3\x5\x3\x5\x3\x5\x3\x5\x3\x5\x3\x6"+
		"\x3\x6\x3\x6\x3\x6\x3\x6\x3\a\x3\a\x3\a\x3\a\a\a:\n\a\f\a\xE\a=\v\a\x3"+
		"\a\x3\a\x3\b\x3\b\x3\b\x3\b\x3\b\x5\b\x46\n\b\x3\b\x3\b\x3\t\x3\t\x3\t"+
		"\x3\n\x3\n\x3\n\x3\n\a\nQ\n\n\f\n\xE\nT\v\n\x3\n\x3\n\x3\v\x3\v\x3\v\x3"+
		"\v\x5\v\\\n\v\x3\f\x3\f\x3\f\x2\x2\x2\r\x2\x2\x4\x2\x6\x2\b\x2\n\x2\f"+
		"\x2\xE\x2\x10\x2\x12\x2\x14\x2\x16\x2\x2\x2\\\x2\x19\x3\x2\x2\x2\x4\x1E"+
		"\x3\x2\x2\x2\x6&\x3\x2\x2\x2\b+\x3\x2\x2\x2\n\x30\x3\x2\x2\x2\f\x35\x3"+
		"\x2\x2\x2\xE@\x3\x2\x2\x2\x10I\x3\x2\x2\x2\x12L\x3\x2\x2\x2\x14[\x3\x2"+
		"\x2\x2\x16]\x3\x2\x2\x2\x18\x1A\x5\x4\x3\x2\x19\x18\x3\x2\x2\x2\x19\x1A"+
		"\x3\x2\x2\x2\x1A\x1B\x3\x2\x2\x2\x1B\x1C\x5\f\a\x2\x1C\x3\x3\x2\x2\x2"+
		"\x1D\x1F\x5\x6\x4\x2\x1E\x1D\x3\x2\x2\x2\x1E\x1F\x3\x2\x2\x2\x1F!\x3\x2"+
		"\x2\x2 \"\x5\b\x5\x2! \x3\x2\x2\x2!\"\x3\x2\x2\x2\"$\x3\x2\x2\x2#%\x5"+
		"\n\x6\x2$#\x3\x2\x2\x2$%\x3\x2\x2\x2%\x5\x3\x2\x2\x2&\'\a\x3\x2\x2\'("+
		"\a\b\x2\x2()\a\x10\x2\x2)*\a\t\x2\x2*\a\x3\x2\x2\x2+,\a\xE\x2\x2,-\a\b"+
		"\x2\x2-.\a\x10\x2\x2./\a\t\x2\x2/\t\x3\x2\x2\x2\x30\x31\a\f\x2\x2\x31"+
		"\x32\a\b\x2\x2\x32\x33\a\x10\x2\x2\x33\x34\a\t\x2\x2\x34\v\x3\x2\x2\x2"+
		"\x35\x36\a\x4\x2\x2\x36\x37\a\b\x2\x2\x37;\a\r\x2\x2\x38:\x5\xE\b\x2\x39"+
		"\x38\x3\x2\x2\x2:=\x3\x2\x2\x2;\x39\x3\x2\x2\x2;<\x3\x2\x2\x2<>\x3\x2"+
		"\x2\x2=;\x3\x2\x2\x2>?\a\xF\x2\x2?\r\x3\x2\x2\x2@\x41\a\x11\x2\x2\x41"+
		"\x42\a\b\x2\x2\x42\x45\a\r\x2\x2\x43\x46\x5\x10\t\x2\x44\x46\x5\x12\n"+
		"\x2\x45\x43\x3\x2\x2\x2\x45\x44\x3\x2\x2\x2\x46G\x3\x2\x2\x2GH\a\xF\x2"+
		"\x2H\xF\x3\x2\x2\x2IJ\a\x6\x2\x2JK\x5\x12\n\x2K\x11\x3\x2\x2\x2LM\a\v"+
		"\x2\x2MN\a\b\x2\x2NR\a\a\x2\x2OQ\x5\x14\v\x2PO\x3\x2\x2\x2QT\x3\x2\x2"+
		"\x2RP\x3\x2\x2\x2RS\x3\x2\x2\x2SU\x3\x2\x2\x2TR\x3\x2\x2\x2UV\a\n\x2\x2"+
		"V\x13\x3\x2\x2\x2W\\\x5\x16\f\x2XY\x5\x16\f\x2YZ\a\x5\x2\x2Z\\\x3\x2\x2"+
		"\x2[W\x3\x2\x2\x2[X\x3\x2\x2\x2\\\x15\x3\x2\x2\x2]^\a\x11\x2\x2^\x17\x3"+
		"\x2\x2\x2\n\x19\x1E!$;\x45R[";
	public static readonly ATN _ATN =
		ATNSimulator.Deserialize(_serializedATN.ToCharArray());
}
