﻿using System;

namespace CutsceneEditor
{
    public class Text
    {
        internal static ushort TextCount = 0;

        public ushort ID { get; private set; }

        public string Value { get; private set; }

        public Actor Actor { get; private set; }

        public Text(string text, Actor actor)
        {
            ID = ++TextCount;

            Value = text;

            Actor = actor;
        }

        public override string ToString()
        {
            string prefix = Actor != null ? Actor.Name + ": " : "";
            return prefix + Value;
        }
    }
}
